package model

import (
	"gorm.io/gorm"
)

type FsProductModel3d struct {
	Id             int64   `gorm:"primary_key" json:"id"`    //
	ProductId      *int64  `gorm:"-" json:"product_id"`      // 产品ID
	Tag            *int64  `gorm:"-" json:"tag"`             // 类别（1：模型，2：配件，3：场景）
	Title          *string `gorm:"-" json:"title"`           // 标题
	Name           *string `gorm:"-" json:"name"`            // 详情页展示名称
	ModelInfo      *string `gorm:"-" json:"model_info"`      // 模型详情
	MaterialId     *int64  `gorm:"-" json:"material_id"`     // 材质ID
	SizeId         *int64  `gorm:"-" json:"size_id"`         // 尺寸ID
	Sort           *int64  `gorm:"-" json:"sort"`            // 排序
	Light          *int64  `gorm:"-" json:"light"`           // 灯光组
	LightList      *string `gorm:"-" json:"light_list"`      // 灯光备选项
	PartId         *int64  `gorm:"-" json:"part_id"`         // 配件选项id（配件就是模型的id）
	PartList       *string `gorm:"-" json:"part_list"`       // 配件备选项
	Status         *int64  `gorm:"-" json:"status"`          // 状态位 显示 删除
	Ctime          *int64  `gorm:"-" json:"ctime"`           // 添加时间
	OptionTemplate *int64  `gorm:"-" json:"option_template"` // 配件绑定的公共模板
	Price          *int64  `gorm:"-" json:"price"`           // 仅配件用，配件的价格, 单位：美分
	Sku            *string `gorm:"-" json:"sku"`             // sku
}
type FsProductModel3dModel struct{ db *gorm.DB }

func NewFsProductModel3dModel(db *gorm.DB) *FsProductModel3dModel { return &FsProductModel3dModel{db} }
